<link rel="import" href="../../bower_components/polymer/polymer-element.html">

<link rel="import" href="../../bower_components/paper-icon-button/paper-icon-button.html">
<link rel="import" href="../../bower_components/paper-dialog/paper-dialog.html">
<link rel="import" href="../../bower_components/paper-button/paper-button.html">
<link rel="import" href="../../bower_components/iron-icons/av-icons.html">
<link rel="import" href="../../bower_components/iron-ajax/iron-ajax.html">

<dom-module id="dez-save-analysis-button">
  <template>
    <style>
    </style>

    <paper-icon-button class="hidden-xxs" icon="cloud-upload" title="save analysis (cloud)" on-tap="_openSaveDialog"></paper-icon-button>

    <paper-dialog id="saveDialog" entry-animation="fade-in-animation" exit-animation="fade-out-animation" with-backdrop>
      <h2><iron-icon icon="cloud-upload"></iron-icon> &nbsp; Save analysis (public cloud)</h2>
      <paper-input label="Analysis name" value="{{_defaultAnalysisName}}" auto-validate pattern="[- _+()@a-zA-Z0-9]*" error-message="Letters, digits, spaces, symbols - + _ ( ) @"></paper-input>
      <p>
        <b>Shared public server.</b>
        On this public account, saved analysis <br /> may be read, replaced, or deleted by everyone.
        <br />
        <br />
        Personal accounts will be available starting from <br />Summer 2019.
        Meanwhile, you can also store <br />your analyses on files on your computer <br /> with the 'save'/'load' buttons.
      </p>
      <div class="buttons">
        <paper-button dialog-dismiss>Cancel</paper-button>
        <paper-button dialog-confirm autofocus  on-tap="_saveAs">OK</paper-button>
      </div>
    </paper-dialog>

    <iron-ajax
        id="AjaxPost"
        url={{analysesLocation}}
        method="POST"
        content-type="application/json"
        handle-as="json">
    </iron-ajax>

  </template>

  <script>

  class DezSaveAnalysisButton extends Polymer.Element {

      static get is() { return 'dez-save-analysis-button'; }

      static get properties() {
          return {
              selectedAnalysis : String,
              analysesLocation : String,
              analysisFiles : Array,
              analysesNames : Array
          }
      }

      set dropdown (element) {
        this._dropdown = element
      }

      set analysis (analysis) {
        this._analysis = analysis
      }

      _openSaveDialog () {
          this._defaultAnalysisName = this.selectedAnalysis.replace(/ /g, "")
          this.$.saveDialog.open();
      }

      async _saveAs () {
          await this._save();
          if (!this.analysesNames.includes(this._defaultAnalysisName)) {
              this.analysisFiles.push({
                  "name": this._defaultAnalysisName,
                  "location": this.analysesLocation
                        + "/" + this._defaultAnalysisName + ".dez"
              })
              this.push('analysesNames', this._defaultAnalysisName);
          }
          this._dropdown.name = this._defaultAnalysisName;
      }

      async _save () {
          this.$.AjaxPost.body = {
              "name": this._defaultAnalysisName + ".dez",
              "content": this._analysis.toJson()
          };
          let request = this.$.AjaxPost.generateRequest();
          try {
              await request.completes;
              this._analysis.backupNeeded = false;
          } catch (err) {
              console.log(err);
          }
      }

  }

  window.customElements.define(DezSaveAnalysisButton.is, DezSaveAnalysisButton);

  </script>
</dom-module>
